#use in combination with fuction find.BMs.R2CV
BM.R2CV.details <- function(mod_data, bestmodel, mod_n=10){
  
  if(colnames(bestmodel)[1]=="V1") k <- 1 else k <- 2
  
  mod_size <- 0
  m <- k
  while (substr(colnames(bestmodel)[m],1,1)=="V") {
    
    mod_size <- mod_size+1
    m <- m+1
    
  }  
  
  var_names <- bestmodel[,k:(k+mod_size-1)]
  element_names <- c()
  
  
  element_names <- 
    
    if(mod_size==1){sapply(1:length(var_names), function(x) 
      
      unlist(strsplit(var_names[x],split='_'))[2])}else
        
    t(sapply(1:nrow(var_names), function(i){
      
      sapply(1:ncol(var_names), function(j) {
        
        unlist(strsplit(var_names[i,j],split='_'))[2]
        
      })
      
    }))
  
  t <- unlist(strsplit(colnames(mod_data)[1],split='_'))
  element <- t[length(t)-1]
  
  element_names_lg <- element_names==element
  
  lg <- if(mod_size==1) element_names_lg else apply(element_names_lg, 1, any)
  
  n <- min(50, nrow(bestmodel))
  
  reranked <- cbind(bestmodel[,k:(k+mod_size+1)],lg)
  
  reranked[1:n,"mod.rank"] <- 1:n
  
  reranked[1:n,] <- reranked[1:n,][order(reranked[1:n,]$lg, decreasing = T),] 
  

  #details
  weight <- matrix(data = NA, nrow = mod_n, ncol = mod_size)
  mod_coef <- matrix(data = NA, nrow = mod_n, ncol = mod_size+1)
  p.value <- matrix(data = NA, nrow = mod_n, ncol = mod_size+1)
  p.symb <- matrix(data = NA, nrow = mod_n, ncol = mod_size+1)
  
  if(mod_size==1) for (x in 1:mod_n){
    
    model <- regr(formula(mod_data[, unlist(c(colnames(mod_data)[1], reranked[x,1:mod_size]))]), 
                  data=mod_data, robust = T)
    
    weight[x,] <- 100
    mod_coef[x,] <- model$coefficients
    p.value[x,] <- model$termtable$p.value
    p.symb[x,] <- model$termtable$p.symb
  }else
  
  for (x in 1:mod_n){
    
    model <- calcLMG(formula(mod_data[, unlist(c(colnames(mod_data)[1], reranked[x,1:mod_size]))]),
                     mod_data, rob = T, rela = T)
    
    weight[x,] <- model$lmgs
    mod_coef[x,] <- model$model$coefficients
    p.value[x,] <- model$model$termtable$p.value
    p.symb[x,] <- model$model$termtable$p.symb
    
  }

  colnames(weight) <- paste("weight_V", c(1:mod_size), sep = "")
  colnames(mod_coef) <- c("intercept", paste("coef_V", c(1:mod_size), sep = ""))  
  colnames(p.value) <- c("intercept", paste("p.value_V", c(1:mod_size), sep = ""))
  colnames(p.symb) <- c("intercept", paste("p.symb_V", c(1:mod_size), sep = ""))
  
  p.value <- p.value[,-1]
  p.symb <- p.symb[,-1]
  p.value <- data.frame(p.value)
  p.symb <- data.frame(p.symb)
  
  #browser()
  
  if(mod_size>1){
    
    p.value[,"sig.lg"] <- !apply(p.value>0.1, 1, any)

  }else{
    
    p.value[,"sig.lg"] <- as.vector(!(p.value>0.1))
    
    }
  
  details <- cbind(reranked[1:mod_n,], weight, mod_coef, p.symb, p.value)

  

  return(details)
  
  
}


