calcLMG <- function(mod_form, mod_data, rob, rela) {
  
  seed <- .Random.seed
  
  if (any(attr(terms(mod_form), "order") != 1)) stop("Formula error: interactions not allowed.")
  
  dep_var <- all.vars(mod_form)[1]
    
  exp_vars <- all.vars(mod_form)[-1]
    
  model_size <- length(exp_vars)
  
  mod_data_noNA <- mod_data[complete.cases(mod_data[, c(dep_var, exp_vars)]), ]
  
  fit_model <- if(rob == T) {function(formula, data) {set.seed(seed); regr(formula, data, robust = T)}
                                                      
               } else if (rob == F) {function(formula, data) regr(formula, data, robust = F, family = "gaussian")} 
                                     
  decomp_rsq <- sapply(1:model_size, function(i) {
      
    exp_vars_m <- exp_vars[c(i:model_size, 1:i - 1)]
    
    combinat <- lapply(1:model_size, function(j) combn(exp_vars_m, j)) 
    
    combinat_rsq <- lapply(1:model_size, function(k) {
      
      sapply(1:ncol(combinat[[k]]), function(l) {
        
        
        summary(fit_model(formula(mod_data_noNA[, c(dep_var, combinat[[k]][, l])]), mod_data_noNA))$r.squared
      })
      
    })
    
    mean(c(combinat_rsq[[1]][1], sapply(2:model_size, function(m) {
      
      mean(sapply(1:choose(model_size - 1, m - 1), function(n) {
        
        combinat_rsq[[m]][n] - combinat_rsq[[m - 1]][choose(model_size - 1, m - 2) + n]
        
      }))
      
    })))
    
  })
  
  names(decomp_rsq) <- exp_vars
  
  complete_model <- fit_model(mod_form, mod_data)
  
  if (rela == T) {
    
    total_rsq <- summary(complete_model)$r.squared 
    
    return(list(model = complete_model, lmgs = (decomp_rsq / total_rsq) * 100))
    
  } else if (rela == F) {
  
    return(list(model = complete_model, lmgs = decomp_rsq))
  }

}